## INTRA Trade Welfare  -- updated March 21, 2018
rm(list = ls(all = TRUE)) ## Clears the workspace
##clibrary(epicalc) ## Used to detach all data command is detachAllData()
library(Rlab)
library(mgcv)
setwd("~/Dropbox/RCM/Religion_Data/welfare_analysis/intratrade")
data <- read.csv("~/Dropbox/RCM/Religion_Data/welfare_analysis/intratrade/trade_data_4_welfare_calculations_INTRA.csv")
attach(data)


# The next statement sets up the martices for the manipulations 
# The way this is programmed if we read across the down the data file and fill
# the numbers in across the rows
num_count = (length(t(data))/length(data))^.5
icountry <- matrix(data[,2],byrow=T,nrow=(length(t(data))/length(data))^.5)
ecountry <- matrix(data[,1],byrow=T,nrow=(length(t(data))/length(data))^.5)
eabrev <- matrix(data[,3],byrow=T,nrow=(length(t(data))/length(data))^.5)
iabrev <- matrix(data[,4],byrow=T,nrow=(length(t(data))/length(data))^.5)
icode <- matrix(data[,6],byrow=T,nrow=(length(t(data))/length(data))^.5)
ecode <- matrix((data[,5]),byrow=T,nrow=(length(t(data))/length(data))^.5)
ilngdp <- matrix(log(data[,8]),byrow=T,nrow=(length(t(data))/length(data))^.5)
elngdp <- matrix(log(data[,7]),byrow=T,nrow=(length(t(data))/length(data))^.5)
dstnc  <- matrix(data[,9],byrow=T,nrow=(length(t(data))/length(data))^.5)
border <- matrix(data[,10],byrow=T,nrow=(length(t(data))/length(data))^.5)
lang<- matrix(data[,11],byrow=T,nrow=(length(t(data))/length(data))^.5)
comcol <- matrix(data[,13],byrow=T,nrow=(length(t(data))/length(data))^.5)
comleg <- matrix(data[,14],byrow=T,nrow=(length(t(data))/length(data))^.5)
comrelig <- matrix(data[,15],byrow=T,nrow=(length(t(data))/length(data))^.5)
ipop <- matrix(data[,17],byrow=T,nrow=(length(t(data))/length(data))^.5)
epop <- matrix(data[,16],byrow=T,nrow=(length(t(data))/length(data))^.5)
fta <- matrix(data[,20],byrow=T,nrow=(length(t(data))/length(data))^.5)
iypc <-  exp(ilngdp)/(ipop)
eypc <-  exp(elngdp)/(epop)
trade <-matrix(data[,22],byrow=T,nrow=(length(t(data))/length(data))^.5)
ldist  <- log(dstnc) 
# Remove the ones on the border variable because will define smcnty variable for own border
border <- border + diag(num_count)

# ********************************* */
# Set Parameters */
# ********************************* */
aa0 <-  0.3756518 # Constant
aa1 <- -1.03; 	# Distance elasticity 
aa2 <-  1.15;		# Contiguity elasticity
aa3 <-  0.41;		# Common Legal
aa4 <-  0.60;   # Common Lang
aa5 <-  0.81;   # Common Colony
aa6 <-  0.25;   # Common Religion
aa4 <-  0.25;		# FTA ealsticity

aadist <- -0.25 ## distance interaction
aalang <-  0.32 ## Language interaction
aarel  <-  0.31 ## Religion interaction
aabor  <- -0.36 ## Contiguity interaction
aaleg  <- -0.14 ## Legal interaction
aacol  <- -0.56 ## Colony interactio
sigma <- 6;
# ********************************* 
#
# ********************************* 
ddist <- fta*(ldist-mean(ldist))
dbord <- fta*(border-mean(border))
dleg <-  fta*(comleg -mean(comleg))
dlang <- fta*(lang-mean(lang))
dcol <-  fta*(comcol-mean(comcol))
drel <-  fta*(comrelig -mean(comrelig))



Tij <- exp(aa0)*dstnc^aa1*exp(border*aa2)*exp(comleg*aa3)*exp(lang*aa4)*exp(comcol*aa5)*exp(comrelig*aa6)
Tij <- Tij*exp(aadist*ddist)*exp(aabor*dbord)*exp(aaleg*dleg)*exp(aacol*dcol)*exp(aarel*drel)*exp(aa4*fta) 
GDP <-		matrix(exp(ilngdp[1:num_count,1]),num_count,1)
theta <-	GDP/sum(GDP)
thetam <- 	t(matrix(theta,nrow=num_count,ncol=num_count))
gdpm <-   t(matrix(GDP,nrow=num_count,ncol=num_count))
D  <-		gdpm*Tij
## trade.id <-	ifelse(trade>0,1,0)+diag((length(t(data))/length(data))^.5)
trade.id <- matrix(1,nrow=num_count,ncol=num_count)
M = matrix(0,nrow=num_count,ncol=num_count)
D0 <- D*t(trade.id)
D1 <- D*trade.id
D2M <- rbind(cbind(M,D0),cbind(D1,M))

pis0 <-	 	rbind(theta,theta)
mm <- 2
i  <- 1
h <- .5
while(mm > .000000001) {
  pis <- h*pis0+(1-h)*D2M%*%pis0^(-1)
  m <- abs(pis-pis0)
  mm <- max(m)
  pis0 <- pis;
  i=i+1}
Pi0 <- matrix(pis[1:num_count,1])
P0  <- matrix(pis[(num_count+1):(num_count+num_count),1])
cor(cbind(Pi0,P0))

ypc <- iypc[,1]
w  <- ypc
ypc.relus <- ypc/ypc[59]
# Calculate technology relative to the US
tech.relus <- ypc.relus*(Pi0/Pi0[59])^(-1/sigma)
# Caclulate GDP and world GDP
gdp <- exp(ilngdp[,1])
pop <- ipop[,1]

ththeta.m <- matrix(theta,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
gdp.m <- matrix(GDP,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)

## Now calcuate tech off of GDP+
phi.sigma <-  (sigma-1)^((sigma-1)/sigma)*sigma^-1
tech.us <- sum(gdp)/(sum(tech.relus*pop)*phi.sigma)
tech <- tech.us*tech.relus
sumtech <- sum(tech*pop)
tt <- matrix(theta,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
country = icountry[,1]
ypc <- iypc[,1]
ypc0 <- ypc 
w  <- ypc
ypc.relus <- ypc/ypc[59]
Pisigma  = Pi0^(1/(1-sigma))
Psigma  = P0^(1/(1-sigma))
## Given the level of technology now create the P's that are consistent
P1msigma = (Tij*trade.id)%*%((tech/w)^sigma*gdp*phi.sigma^sigma)
P1msigma2 = (Tij*trade.id)%*%(phi.sigma^sigma*(tech/w)^sigma*gdp)
## Given the P's we can now calculate the Pi's ##
Pi1msigma <- (gdp.m*Tij*t(trade.id))%*%(P1msigma^(-1))
## Calculate the P's and the Pi's -- i.e. raise the Pi1msigma and p1msigma to (1/1-sigma) power
Pi01 <- Pi1msigma^(1/(1-sigma))
P01 <- P1msigma^(1/(1-sigma))

##
##This is a check on the normalization ## 
## mm should some to unity--this is the check on the wage-normalization ##
mm <- (tech/w)^sigma*gdp*Pi1msigma*phi.sigma^sigma
sum(mm)/sum(GDP)
mm <- (tech/w)^sigma*gdp*Pi1msigma*phi.sigma^sigma
sum(mm)/sum(GDP)
##
##
## Let us do a check on actual GDP ##
gdp2 = pop*tech*Pi1msigma^(1/sigma)*phi.sigma;
cbind(gdp2,gdp)
# Create the matrices that allow for some checks of the model
# Matrix of the Pi's  -- each column represents a country (denoted by byrow=T)
Pi0m <- matrix(Pi1msigma,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
# Matrix of the P's  -- each row represents a country (denoted by byrow=F)
P0m <- matrix(P1msigma,byrow=F,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
vp0 <- (Pi0m*P0m)^(-1)
sij = vp0*D1
betaji0 = t(vp0*D0)


pairs <- matrix(0,num_count*num_count,15)
kk <- 0 
ii <- 1 
while(ii<=num_count)  {
  jj <- 1
  while(jj<=num_count) {  
    if(fta[ii,jj]==0) {
      kk <- kk+1 
      pairs[kk,1] <- fta[ii,jj]
      pairs[kk,2] <- ypc[ii]
      pairs[kk,3] <- P01[ii]
      pairs[kk,4] <- ypc0[ii]
      pairs[kk,5] <- P01[ii]
      pairs[kk,6] <- ypc[jj]
      pairs[kk,7] <- P01[jj]
      pairs[kk,8] <- ypc0[jj]
      pairs[kk,9] <- P01[jj]
      pairs[kk,10] <- Tij[ii,ii]
      pairs[kk,11] <- Tij[jj,jj]
      pairs[kk,12] <- betaji0[jj,jj]
      pairs[kk,13] <- betaji0[ii,ii]
      pairs[kk,14] <- betaji0[ii,jj]
      pairs[kk,15] <- betaji0[jj,ii]
      jj <- jj+1
    }
    else if(ii==jj) {
      kk <- kk+1 
      pairs[kk,1] <- fta[ii,jj]
      pairs[kk,2] <- ypc[ii]
      pairs[kk,3] <- P01[ii]
      pairs[kk,4] <- ypc0[ii]
      pairs[kk,5] <- P01[ii]
      pairs[kk,6] <- ypc[jj]
      pairs[kk,7] <- P01[jj]
      pairs[kk,8] <- ypc0[jj]
      pairs[kk,9] <- P01[jj]
      pairs[kk,10] <- Tij[ii,ii]
      pairs[kk,11] <- Tij[jj,jj]
      pairs[kk,12] <- betaji0[jj,jj]
      pairs[kk,13] <- betaji0[ii,ii]
      pairs[kk,14] <- betaji0[ii,jj]
      pairs[kk,15] <- betaji0[jj,ii]
      jj <- jj+1
    }
    else {
      
      ilngdp <- matrix(log(data[,8]),byrow=T,nrow=(length(t(data))/length(data))^.5)
      elngdp <- matrix(log(data[,7]),byrow=T,nrow=(length(t(data))/length(data))^.5)
      ipop <- matrix(data[,17],byrow=T,nrow=(length(t(data))/length(data))^.5)
      epop <- matrix(data[,16],byrow=T,nrow=(length(t(data))/length(data))^.5)
      
      ## **********************************  ##
      ## Change FTA 's to zero 
      ## **********************************  ##
      fta <- matrix(data[,20],byrow=T,nrow=(length(t(data))/length(data))^.5)
      ## Change the trade cost for pair of interest
      fta[ii,jj] <- 0
      fta[jj,ii] <- 0
      ddist <- fta*(ldist-mean(ldist))
      dbord <- fta*(border-mean(border))
      dleg <-  fta*(comleg -mean(comleg))
      dlang <- fta*(lang-mean(lang))
      dcol <-  fta*(comcol-mean(comcol))
      drel <-  fta*(comrelig -mean(comrelig))
      
      Tij2 <- exp(aa0)*dstnc^aa1*exp(border*aa2)*exp(comleg*aa3)*exp(lang*aa4)*exp(comcol*aa5)*exp(comrelig*aa6)
      Tij2 <- Tij2*exp(aadist*ddist)*exp(aabor*dbord)*exp(aaleg*dleg)*exp(aacol*dcol)*exp(aarel*drel)*exp(aa4*fta) 
      ## Reset the GDP values
      gdp2 <- gdp
      ## Reset the theta for the experiment
      theta_e = gdp2/sum(gdp2)
      ## Calculate (new) per capita GDP ##
      w.row = gdp2/(pop)
      w2row = w.row
      ##  Begin iteration to derive the new distribution of world income
      vv <-  1
      wage_diff <- max(w2row) 
      diffw <- wage_diff
      pis0 <-	 	rbind(theta,theta)
      mm <- 2
      i  <- 1
      h <- .5
      while(diffw > .00000001) {
        ## Calculate the new level of GDP
        gdp.e <- w.row*pop
        ## Relcaclulate the thetas
        theta.e <- gdp.e/sum(gdp.e)
        
        ## Formulate a new matrix for the theta based on the experiment as the guess to new GDP
        gdpm.e <- t(matrix(gdp.e,nrow=num_count,ncol=num_count))
        ## Calculate trade cost matrix weighted by the guess at GDP shares
        D.e <- gdpm.e*Tij2
        M = matrix(0,nrow=num_count,ncol=num_count)
        D0.e <- D.e*t(trade.id)
        D1.e <- D.e*trade.id
        ## Formulate new trade cost matrix
        Dm.e <- rbind(cbind(M,D0.e),cbind(D1.e,M))
        ## Guess at new price terms
        pis.e = c(theta.e,theta.e);
        ## Set-up initial parameters for simulation/iteration
        mm.e=2;
        mm = 10;
        i=1;
        h=.5;
        
        while(mm.e> .00000001) {
          pis <- h*pis.e+(1-h)*Dm.e%*%pis.e^(-1)
          m <- abs(pis-pis.e)
          mm.e <- max(m)
          pis.e <- pis;
          i=i+1
        }
        pis1 <- matrix(pis[1:num_count,1])
        p1  <- matrix(pis[(num_count+1):(num_count+num_count),1]) 
        ## ************************************************  ##
        ##  Normalize the price terms ##
        ## ************************************************  ##
        
        ## Calculate the new relative wages ##
        w.relus = (tech/(tech[59]))*(pis1/pis1[59])^(1/sigma)
        ## Caclulate (new) wage rate for US ##
        wus.new = phi.sigma*sumtech/(sum(w.relus*pop))
        ## Calculate new world wages ##
        w.newrow = wus.new*w.relus
        ## Compute new GDP ##
        gdp.new <- w.newrow*pop
        ## New GDP Shares ##
        theta2 <- gdp.new/sum(gdp.new)
        ## Calculate the new Pi^(1-\sigma) ##
        wage.diff= max(w.newrow-w.row)
        diffw=wage.diff;
        w.row=w.newrow;
        vv=vv+1;
        gdp.e <- gdp.new
      }
      gdpm.new <- t(matrix(gdp.new,nrow=num_count,ncol=num_count))
      ypc.new <- (gdp.new/ipop[,1])
      Pi1 <- matrix(pis[1:num_count,1])
      P1  <- matrix(pis[(num_count+1):(num_count+num_count),1])
      cor(cbind(Pi1,P1))
      Pisigma1  = Pi1^(1/(1-sigma))
      Psigma1  = P1^(1/(1-sigma))
      ## Given the level of technology now create the P's that are consistent
      P1msigma1 = (Tij2*trade.id)%*%((tech/w.row)^sigma*gdp.new*phi.sigma^sigma)
      theta2.m <- matrix(theta2,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
      gdp2.m <- matrix(gdp.new,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
      P1msigma2 = (Tij2*trade.id)%*%(phi.sigma^sigma*(tech/w.row)^sigma*gdp.new)
      ## Given the P's we can now calculate the Pi's ##
      Pi1msigma2 <- (gdpm.new*Tij2*t(trade.id))%*%(P1msigma1^(-1))
      # Create the matrices that allow for some checks of the model
      # Matrix of the Pi's  -- each column represents a country (denoted by byrow=T)
      Pi1m <- matrix(Pi1msigma2,byrow=T,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
      # Matrix of the P's  -- each row represents a country (denoted by byrow=F)
      P1m <- matrix(P1msigma2,byrow=F,nrow=(length(t(data))/length(data))^.5,ncol=(length(t(data))/length(data))^.5)
      vp1 <- (Pi1m*P1m)^(-1)
      sij1 = vp1*D1.e
      betaji1 = t(vp1*D0.e)
      
      ## Calculate the P's and the Pi's -- i.e. raise the Pi1msigma and p1msigma to (1/1-sigma) power
      Pi11 <- Pi1msigma2^(1/(1-sigma))
      P11 <- P1msigma2^(1/(1-sigma))
      fta <- matrix(data[,20],byrow=T,nrow=(length(t(data))/length(data))^.5)
      kk <- kk+1 
      pairs[kk,1] <- fta[ii,jj]
      pairs[kk,2] <- ypc.new[ii]
      pairs[kk,3] <- P11[ii]
      pairs[kk,4] <- ypc0[ii]
      pairs[kk,5] <- P01[ii]
      pairs[kk,6] <- ypc.new[jj]
      pairs[kk,7] <- P11[jj]
      pairs[kk,8] <- ypc0[jj]
      pairs[kk,9] <- P01[jj]
      pairs[kk,10] <- Tij[ii,ii]
      pairs[kk,11] <- Tij[jj,jj]
      pairs[kk,12] <- betaji1[jj,jj]
      pairs[kk,13] <- betaji1[ii,ii]
      pairs[kk,14] <- betaji1[ii,jj]
      pairs[kk,15] <- betaji1[jj,ii]
      
      
      
      jj <- jj+1
    }
  }
  ii <- ii+1
}
zzz <- data.frame(data[,4],data[,3],pairs)
zzz <- cbind(zzz,((pairs[,2]/pairs[,3])-1)*100,((pairs[,4]/pairs[,5])-1)*100,((pairs[,6]/pairs[,7])-1)*100,((pairs[,8]/pairs[,9])-1)*100)
xzz <- data.frame(data[,1],data[,2],zzz)
setwd("~/Dropbox/RCM/Religion_Data/welfare_analysis/intratrade")
write.csv(xzz,file="welfare_effects_nov_15_2014.csv")


